#include <stdio.h>

int child(char *cmd, FILE **input, FILE **output) {
  int childpid, pipe1[2], pipe2[2];

  if ((pipe(pipe1) < 0) || (pipe(pipe2) < 0)) {
    perror("pipe"); 
    exit(-1);
  }
  if ((childpid = fork()) <0) {
    perror("fork");
    exit(-1);
  } else if (childpid > 0) {
    close(pipe1[0]);
    close(pipe2[1]); 
    *input  = fdopen(pipe2[0], "r");
    *output = fdopen(pipe1[1], "w");
    return childpid;
  } else {
    dup2(pipe1[0], 0);
    dup2(pipe2[1], 1);
    close(pipe1[1]);
    close(pipe2[0]); 
    if (execlp(cmd, cmd, NULL) < 0)
      perror("execlp");
  }    
}
