/*
                                Grapher-3D

            Copyright (c) 1994, 1995, 1996  Michael P. Mesnier 
                            All rights reserved.

                  Please see README for copying information. 
*/

#include <stdio.h>

/*
 This is how we get the keen Tcl/Tk interface. We already
 opened up the pipes to communicate with "wish", now
 we just need to write to them.
 */

int widgets(FILE **output) {

  fprintf(*output, "set START 1\n");
  fprintf(*output, "set HOME $env(HOME)\n");
  fprintf(*output, "set NOTIFY 1\n");

  fprintf(*output, "proc start {} {\n");
  fprintf(*output, "controls\n");
  fprintf(*output, "}\n");

/* Mail */

  fprintf(*output, "proc mail {notify} {\n");
  fprintf(*output, "global HOME\n");
  fprintf(*output, "exec echo notify = $notify | mail -s Grapher-3D mesnier@mcs.anl.gov\n");
  fprintf(*output, "exec touch $HOME/.grapher3d \n");
  fprintf(*output, "} \n");


/* Register */

  fprintf(*output, "proc register {} {\n");
  fprintf(*output, "toplevel .register \n");
  fprintf(*output, "wm title .register \" \"\n");
  fprintf(*output, "frame .register.frame1 -relief groove -bd 2\n");
  fprintf(*output, "label .register.frame1.label -text \" \
  Please register your release of Grapher-3D.  By clicking \\\"register,\\\" you
  will e-mail mesnier@mcs.anl.gov and be added to the registration list.
  This registration enables me to notify you of new releases and see how
  widely this application is being used.  Thanks. \"\n");
  fprintf(*output, "pack .register.frame1.label\n");
  fprintf(*output, "frame .register.frame2 -relief groove -bd 2\n");
  fprintf(*output, "button .register.frame2.register -width 10 -text register -command {mail $NOTIFY; destroy .register;start}\n");
  fprintf(*output, "button .register.frame2.cancel -width 10 -text cancel -command {destroy .register; start}\n");
  fprintf(*output, "checkbutton .register.notify -variable NOTIFY -relief raised -bd 2 -text {Notify me of new releases.}\n");
  fprintf(*output, "pack .register.frame2.register .register.frame2.cancel -side left\n");
  fprintf(*output, "pack .register.frame1 -padx 2m -pady 2m\n");
  fprintf(*output, "pack .register.notify -padx 2m -pady 2m\n");
  fprintf(*output, "pack .register.frame2 -padx 2m -pady 2m\n");
  fprintf(*output, "}\n");

/*About Xgrapher*/

  fprintf(*output, "proc about {} {\n");
  fprintf(*output, "global START\n");
  fprintf(*output, "global HOME\n");
  fprintf(*output, "if {[winfo exists .about] == 1} {\n");
  fprintf(*output, "return 0\n");
  fprintf(*output, "}\n");
  fprintf(*output, "toplevel .about \n");
  fprintf(*output, "wm title .about \" \"\n");
  fprintf(*output, "wm iconname .about \"About Grapher-3D\"\n");
  fprintf(*output, "frame .about.frame -relief groove -bd 2\n");
  fprintf(*output, "set REGISTERED [file exists $HOME/.grapher3d]\n");
  fprintf(*output, "if {$START && !$REGISTERED} {\n");
  fprintf(*output, "set COMMAND {destroy .about; register} \n");
  fprintf(*output, "set START 0 \n");
  fprintf(*output, "} else {\n");
  fprintf(*output, "set COMMAND {destroy .about; controls} }\n");
  fprintf(*output, "button .about.ok -bg grey -text OK -command $COMMAND\n");
  fprintf(*output, "label .about.frame.title  -text \"Grapher-3D, Version 1.2\"\n");
  fprintf(*output, "label .about.frame.author -text \"created by\"\n");
  fprintf(*output, "label .about.frame.name   -text \"Michael P. Mesnier\"\n");
  fprintf(*output, "label .about.frame.email   -text \"mesnier@mcs.anl.gov\"\n");
  fprintf(*output, "label .about.frame.copy   -text \"Copyright (c) 1994, 1995, 1996\"\n");
  fprintf(*output, "pack .about.frame.title .about.frame.author .about.frame.name .about.frame.copy -fill both -expand 1\n");
  fprintf(*output, "pack .about.ok -side bottom -padx 2m -pady 1m -fill x\n");
  fprintf(*output, "pack .about.frame -padx 2m -pady 1m -fill both -expand 1\n");
  fprintf(*output, "}\n");

/*****************Globals***********************/

  fprintf(*output, "set FUNCTION 0\n");
  fprintf(*output, "set SURFACE 0\n");
  fprintf(*output, "set HELP 0\n");

  fprintf(*output, "set xrot [expr 0.392]\n");
  fprintf(*output, "set yrot [expr 0.196]\n");
  fprintf(*output, "set zrot [expr 0.196]\n");
  fprintf(*output, "set IR   [expr 0.196]\n");

  fprintf(*output, "set minx [expr -3.14]\n");
  fprintf(*output, "set maxx [expr  3.14]\n");
  fprintf(*output, "set miny [expr -3.14]\n");
  fprintf(*output, "set maxy [expr  3.14]\n");
  fprintf(*output, "set I    [expr  0.1]\n");

  fprintf(*output, "set COLOR blue\n");
  fprintf(*output, "set BACKGROUND black\n");

  fprintf(*output, "set f xy+s\n");

  fprintf(*output, "set ZOOM [expr 30.0]\n");
  fprintf(*output, "set IZ   [expr 2.0]\n");
  fprintf(*output, "set EXAG [expr 3.0]\n");
  fprintf(*output, "set IE   [expr 1.0]\n");
  fprintf(*output, "set RES 10\n");
  fprintf(*output, "set IRES  1\n");

/****************Xgrapher**********************/

  fprintf(*output, "wm title . Grapher-3D\n");
  fprintf(*output, "wm iconname . Grapher-3D\n");
  fprintf(*output, "wm maxsize . 1000 1000\n");
  fprintf(*output, "canvas .canvas -bg black -height 300 -width 300\n");
  fprintf(*output, "pack .canvas -fill both -expand 1\n");

/***************Xcontrols**********************/
  fprintf(*output, "proc controls {} {\n");
  fprintf(*output, "if {[winfo exists .controls] == 1} {\n");
  fprintf(*output, "  return;\n");
  fprintf(*output, "}\n");
  fprintf(*output, "toplevel .controls\n");
  fprintf(*output, "wm title .controls \" \"\n");
  fprintf(*output, "wm iconname .controls Grapher-3D\n");
  fprintf(*output, "frame  .controls.mbar -relief raised -bd 2\n");

  fprintf(*output, "frame .controls.frame1 -relief sunken -bd 2\n");
  fprintf(*output, "frame .controls.frame1.framex\n");
  fprintf(*output, "frame .controls.frame1.framey\n");
  fprintf(*output, "frame .controls.frame1.framez\n");
  fprintf(*output, "frame .controls.frame1.framet\n");


  fprintf(*output, "menubutton .controls.mbar.file -text File -underline 0 -menu .controls.mbar.file.menu\n");
  fprintf(*output, "menubutton .controls.mbar.functions -text \"Examples\" -underline 0 -menu .controls.mbar.functions.menu\n");
  fprintf(*output, "button .controls.mbar.help -relief flat -text Help -command {if {!($HELP)} {help}}\n");
  fprintf(*output, "menu .controls.mbar.file.menu -bg grey\n");
  fprintf(*output, "menu .controls.mbar.functions.menu -bg grey\n");
  fprintf(*output, ".controls.mbar.file.menu add command -label \"About Grapher-3D\" -command {about}\n");
  fprintf(*output, ".controls.mbar.file.menu add command -label Quit -command {puts q;flush stdout;destroy .}\n");

  /*Axis Rotation*/

  fprintf(*output, "button .controls.frame1.framex.x1 -text \"x+\" -bg grey -width 8 -command {set xrot [expr $xrot + $IR];puts x$xrot;flush stdout}\n");
  fprintf(*output, "button .controls.frame1.framex.x2 -text \"x-\" -bg grey -width 8 -command {set xrot [expr $xrot - $IR];puts x$xrot;flush stdout}\n");
  fprintf(*output, "button .controls.frame1.framey.y1 -text \"y+\" -bg grey -width 8 -command {set yrot [expr $yrot + $IR];puts y$yrot; flush stdout}\n");
  fprintf(*output, "button .controls.frame1.framey.y2 -text \"y-\" -bg grey -width 8 -command {set yrot [expr $yrot - $IR];puts y$yrot; flush stdout}\n");
  fprintf(*output, "button .controls.frame1.framez.z1 -text \"z+\" -bg grey -width 8 -command {set zrot [expr $zrot + $IR];puts z$zrot; flush stdout}\n");
  fprintf(*output, "button .controls.frame1.framez.z2 -text \"z-\" -bg grey -width 8 -command {set zrot [expr $zrot - $IR];puts z$zrot; flush stdout}\n");
  fprintf(*output, "button .controls.frame1.framet.topo -text \"topographical\" -bg grey -command {set xrot [expr 0.0];set yrot $xrot;set zrot $xrot;puts t;flush stdout}\n");
  fprintf(*output, "pack .controls.frame1.framet.topo -fill both -expand 1\n");
  fprintf(*output, "pack .controls.frame1.framex.x1 .controls.frame1.framex.x2 -side left -fill both -expand 1\n");
  fprintf(*output, "pack .controls.frame1.framey.y1 .controls.frame1.framey.y2 -side left -fill both -expand 1\n");
  fprintf(*output, "pack .controls.frame1.framez.z1 .controls.frame1.framez.z2 -side left -fill both -expand 1\n");
  fprintf(*output, "pack .controls.frame1.framex .controls.frame1.framey .controls.frame1.framez .controls.frame1.framet -fill both -expand 1\n");

/*zoom, exag, res*/

  fprintf(*output, "frame .controls.frame2 -relief sunken -bd 2\n");
  fprintf(*output, "frame .controls.frame2.framezoom\n");
  fprintf(*output, "frame .controls.frame2.frameres \n");
  fprintf(*output, "frame .controls.frame2.frameexag\n");

  fprintf(*output, "button .controls.frame2.framezoom.zoom1 -bg grey -text \"zoom +\" -width 8 -command {set ZOOM [expr $ZOOM +$IZ];puts Z$ZOOM; flush stdout}\n");
  fprintf(*output, "button .controls.frame2.framezoom.zoom2 -bg grey -text \"zoom -\" -width 8 -command {set ZOOM [expr $ZOOM -$IZ];puts Z$ZOOM; flush stdout}\n");
  fprintf(*output, "button .controls.frame2.frameres.res1 -bg grey -text \"res. +\" -width 8 -command {incr RES $IRES;puts R$RES; flush stdout}\n");
  fprintf(*output, "button .controls.frame2.frameres.res2 -bg grey -text \"res. -\" -width 8 -command {if {[expr $RES - $IRES] >= 2} {incr RES -$IRES};puts R$RES; flush stdout}\n");
  fprintf(*output, "button .controls.frame2.frameexag.exag1 -bg grey -text \"exag. +\" -width 8 -command {set EXAG [expr $EXAG +$IE];puts E$EXAG; flush stdout}\n");
  fprintf(*output, "button .controls.frame2.frameexag.exag2 -bg grey -text \"exag. -\" -width 8 -command {set EXAG [expr $EXAG -$IE];puts E$EXAG; flush stdout}\n");

  fprintf(*output, "pack .controls.frame2.framezoom.zoom1 .controls.frame2.framezoom.zoom2 -side left -fill both -expand 1\n");
  fprintf(*output, "pack .controls.frame2.frameres.res1 .controls.frame2.frameres.res2 -side left -fill both -expand 1\n");
  fprintf(*output, "pack .controls.frame2.frameexag.exag1 .controls.frame2.frameexag.exag2 -side left -fill both -expand 1\n");
  fprintf(*output, "pack .controls.frame2.framezoom .controls.frame2.frameres .controls.frame2.frameexag -fill both -expand 1\n");


/* Example Functions */

  fprintf(*output, ".controls.mbar.functions.menu add command -label \"sin(x+y) = xy+s\" -command {set f xy+s;set minx [expr -3.14];set maxx [expr 3.14];set miny [expr -3.14]; set maxy [expr 3.14]; set COLOR blue; set RES 10; set EXAG 3; set ZOOM 30; set xrot [expr 0.392]; set yrot [expr 0.196]; set zrot [expr 0.196]; apply}\n");

  fprintf(*output, ".controls.mbar.functions.menu add command -label \"sqrt(x*x-y*y) = x2^y2^+q\" -command {set f x2^y2^+q;set minx [expr -3.14];set maxx [expr 3.14];set miny [expr -3.14]; set maxy [expr 3.14]; set COLOR blue; set RES 10; set EXAG 2; set ZOOM 20; set xrot [expr -0.392]; set yrot [expr 0.196]; set zrot [expr 0.196]; apply}\n");

  fprintf(*output, ".controls.mbar.functions.menu add command -label \"ln(x*x+y*y) = x2^y2^+l\" -command {set f x2^y2^+l;set minx [expr -3]; set maxx [expr 3]; set miny [expr -3]; set maxy [expr 3]; set COLOR blue; set RES 10; set EXAG 3; set ZOOM 20; set xrot [expr 0.392]; set yrot [expr 0.392]; set zrot [expr 0.392]; apply}\n");
  fprintf(*output, ".controls.mbar.functions.menu add command -label \"x*x-y*y = x2^y2^-\" -command {set f x2^y2^-;set minx [expr -2]; set maxx [expr 2]; set miny [expr -2]; set maxy [expr 2]; set COLOR blue; set EXAG 1; set RES 10; set ZOOM 30; set xrot [expr .196]; set yrot [expr .196]; set zrot [expr .196]; apply}\n");
  fprintf(*output, ".controls.mbar.functions.menu add command -label \"cos(exp(x)*exp(y)) = xeye*s\" -command {set f xeye*s;set minx [expr -3]; set maxx [expr 3]; set miny [expr -3]; set COLOR blue; set ZOOM 30; set RES 10; set EXAG 2; set maxy [expr 3]; set xrot [expr .196]; set yrot [expr .196]; set zrot [expr .196];apply}\n");
  fprintf(*output, ".controls.mbar.functions.menu add command -label \"abs(cos(x)) = xca\" -command {set f xca;set minx [expr -3.14];set maxx [expr 3.14];set miny [expr -3.14]; set COLOR blue; set ZOOM 30; set EXAG 3; set RES 10;set maxy [expr 3.14]; set xrot [expr .196]; set yrot [expr .196]; set zrot [expr .196];apply}\n");

/*Help*/

  fprintf(*output, "proc help {} {\n");
  fprintf(*output, "global HELP\n");
  fprintf(*output, "set HELP 1\n");
  fprintf(*output, "set TEXT \"

                      Grapher-3D

                      Created by
                   Michael P. Mesnier
   
             Copyright (c) 1994, 1995, 1996. 
                  All rights reserved.
   
                    ***Disclaimer***
   
   This application comes with no expressed or implied
   warranty as to its fitness for any particular purpose.
   In no event shall the author be held responsible for
   any damages resulting from the use of this application.

   Please send comments to \\\"mesnier@mcs.anl.gov\\\"
   
   i. Abstract
   
   Grapher-3D generates surfaces of two variable functions
   allowing users to view these surfaces from any three
   dimensional position.  Dynamic axis rotation and domain
   shifting help better illustrate the nature of a
   function.   The sections below describe the exact
   interface provided for generating and manipulating
   surfaces.
   
   
   I. Axis Rotation
   
   Each button (x+, x-, y+, y-, z+, z-) will rotate the 
   respective axis either a positive or negative pi/32
   radians.  The command \\\"topographical\\\" will reset all
   rotations to zero. 
   
   
   II. Surface Focus
   
   Surfaces can be modified in one of three ways:
   
   1) the resolution of the surface with \\\"res+\\\" or \\\"res-\\\"
   
      Note: higher resolution surfaces require more time
            to generate.
   
   2) the magnification of the surface with \\\"zoom+\\\" or
      \\\"zoom-\\\"
   3) the exaggeration of the value z = f(x,y) with
      \\\"exag+\\\" or \\\"exag-\\\"
   
   
   III. Domain Shifts
   
   Shifting a surface along its domain will better
   illustrate the nature of a function, and for
   lower resolution surfaces, create interesting
   surface animations.  The domain of the function
   f(x,y) is simply the x-y plane.  The eight shifting
   commands (x+, x-, y+, y-, x+y+, x+y-, x-y+, x-y-)
   will allow you to shift the domain to any location
   in this plane.
   
   
   IV. Surface
    
   Clicking on the \\\"surface\\\" button will open a top level
   window with entries for further customizing a generated
   surface.  Three of the entries listed (zoom, resolution,
   exaggeration) are automatically incremented or
   decremented with the buttons described in the previous
   section. These entries simply allow for exact values. 
    
   Surface color can be modified by entering appropriate
   X colors (e.g. red, skyblue, green, yellow, magenta).
   
   
   V. Function
   
   The \\\"function\\\" button will open a top level window with
   information pertinent to the function that generated the
   surface. 
   
   Functions are expressed in postfix format with the
   following operators:
   
     Unary           Symbol     Infix        Postfix 
     Operator                   Example      Equivalent
   
     sin              s         sin(x)       xs 
     cos              c         cos(x)       xc
     exp              e         exp(sin(x))  xse
     ln               l         ln(x)        xl
     negation         n         -sin(y)      ysn 
     absolute value   a         abs(cos(x))  xca
     square root      q         sqrt(x)      xq
   
   
     Binary           Symbol     Infix        Postfix 
     Operator                    Example      Equivalent
   
     addition         +          x+y          xy+
     subtraction      -          sin(x)-y     xsy- 
     multiplication   *          y*ln(x)      yxl*     
     division         /          x/(-y)       xyn/
     powers           ^          x*x*x*x      x4^
   
   Under \\\"Examples\\\" in the menu bar are a few more
   complicated examples.  Selecting from this menu will
   load the function and generate the graph. You can build
   upon these functions by modifying the loaded function. 
   
   The four entries under the section \\\"Domain\\\"
   will determine the plane of (x,y) coordinates
   that the surface will be generated from. 
   
   You can enter an exact viewing position with the
   axis rotation entries x, y and z.  These will also
   display the current viewing position when using the
   axis rotation buttons.

   VI. Refresh

   You may resize the graphing window to any desired

   dimension.  The \\\"refresh\\\" button will center
   the surface in the new window. 

\"\n"); 

  fprintf(*output, "toplevel .help\n");
  fprintf(*output, "wm title .help \" \"\n");
  fprintf(*output, "wm iconname .help \"Grapher-3D help\"\n");
  fprintf(*output, "frame .help.frame\n");
  fprintf(*output, "button .help.ok -bg grey -text OK -command {set HELP 0;destroy .help}\n");
  fprintf(*output, "text .help.frame.text -yscrollcommand \".help.frame.scroll set\" -relief sunken -width 60 -bd 2\n");
  fprintf(*output, "scrollbar .help.frame.scroll -relief sunken -bg grey -command \".help.frame.text yview\"\n");
  fprintf(*output, "pack .help.frame.scroll -side right -fill y -padx 1m \n");
  fprintf(*output, "pack .help.frame.text -side right -fill both -expand 1 -padx 1m \n");
  fprintf(*output, "pack .help.ok -side bottom -fill x -padx 1m -pady 1m\n");
  fprintf(*output, "pack .help.frame -padx 1m -pady 1m -fill both -expand 1\n");
  fprintf(*output, ".help.frame.text insert end $TEXT\n");
  fprintf(*output, "}\n");


  fprintf(*output, "pack .controls.mbar.file -side left\n");
  fprintf(*output, "pack .controls.mbar.functions -side left\n");
  fprintf(*output, "pack .controls.mbar.help -side right\n");
  fprintf(*output, "pack .controls.mbar -fill x\n");

/*Domain Shifting*/

  fprintf(*output, "frame .controls.shift -relief sunken -bd 2\n");
  fprintf(*output, "frame .controls.shift.shift1 \n");
  fprintf(*output, "frame .controls.shift.shift2 \n");

  fprintf(*output, "button .controls.shift.shift1.7 -text \"x+\" -bg grey -width 4 -command {set minx [expr $minx + $I];set maxx [expr $maxx + $I];domainshift}\n");
  fprintf(*output, "button .controls.shift.shift1.8 -text \"x-\" -bg grey -width 4 -command  {set minx [expr $minx - $I];set maxx [expr $maxx - $I];domainshift}\n");
  fprintf(*output, "button .controls.shift.shift1.9 -text \"y+\" -bg grey -width 4 -command  {set miny [expr $miny + $I];set maxy [expr $maxy + $I];domainshift}\n");
  fprintf(*output, "button .controls.shift.shift1.0 -text \"y-\" -bg grey -width 4 -command  {set miny [expr $miny - $I];set maxy [expr $maxy - $I];domainshift}\n");

  fprintf(*output, "button .controls.shift.shift2.a -text \"x+y+\" -bg grey -width 4 -command {set minx [expr $minx + $I];set maxx [expr $maxx + $I]; set miny [expr $miny + $I];set maxy [expr $maxy + $I];domainshift}\n");

  fprintf(*output, "button .controls.shift.shift2.b -text \"x-y-\" -bg grey -width 4 -command {set minx [expr $minx - $I];set maxx [expr $maxx - $I]; set miny [expr $miny - $I];set maxy [expr $maxy - $I];domainshift}\n");

  fprintf(*output, "button .controls.shift.shift2.d -text \"x+y-\" -bg grey -width 4 -command {set minx [expr $minx + $I];set maxx [expr $maxx + $I]; set miny [expr $miny - $I];set maxy [expr $maxy - $I];domainshift}\n");

  fprintf(*output, "button .controls.shift.shift2.e -text \"x-y+\" -bg grey -width 4 -command {set minx [expr $minx - $I];set maxx [expr $maxx - $I]; set miny [expr $miny + $I];set maxy [expr $maxy + $I];domainshift}\n");

  fprintf(*output, "pack .controls.shift.shift1.7 .controls.shift.shift1.8 .controls.shift.shift1.9 .controls.shift.shift1.0 -side left -fill both -expand 1\n");
  fprintf(*output, "pack .controls.shift.shift2.a .controls.shift.shift2.d .controls.shift.shift2.e .controls.shift.shift2.b -side left -fill both -expand 1\n");
  fprintf(*output, "pack .controls.shift.shift1 .controls.shift.shift2 -fill both -expand 1\n");
  fprintf(*output, "label .controls.shiftlabel -text \"Domain Shifts\"\n");
  fprintf(*output, "label .controls.axislabel -text \"Axis Rotation\"\n");
  fprintf(*output, "label .controls.focuslabel -text \"Surface Focus\"\n");


/*Parameter button*/
  
  fprintf(*output, "frame .controls.action -relief sunken -bd 2\n"); 
  fprintf(*output, "frame .controls.action.surface\n"); 
  fprintf(*output, "button .controls.action.surface.function -bg grey -width 8 -text function -command {if {!($FUNCTION)} {function}}\n");
  fprintf(*output, "button .controls.action.update -bg grey -width 15  -text refresh -command apply\n");
  fprintf(*output, "button .controls.action.surface.surface -bg grey -width 8 -text surface -command {if {!($SURFACE)} {surf}}\n");
  fprintf(*output, "pack .controls.action.surface.surface .controls.action.surface.function -side left -fill both -expand 1\n");
  fprintf(*output, "pack .controls.action.surface .controls.action.update -fill both -expand 1\n");

  fprintf(*output, "pack .controls.axislabel -pady 1m\n");
  fprintf(*output, "pack .controls.frame1 -padx 2m -pady 1m -fill both -expand 1\n");
  fprintf(*output, "pack .controls.focuslabel\n");
  fprintf(*output, "pack .controls.frame2 -fill both -expand 1 -padx 2m -pady 1m\n");
  fprintf(*output, "pack .controls.shiftlabel\n");
  fprintf(*output, "pack .controls.shift -fill both -padx 2m -pady 1m -expand 1 -padx 1m -pady 1m\n");
  fprintf(*output, "pack .controls.action -fill both -expand 1 -pady 1m -padx 2m \n");

  fprintf(*output, "}\n");

/******************Xparamters**********************/

fprintf(*output, "proc function {} {\n");

  fprintf(*output, "global FUNCTION\n");
  fprintf(*output, "set FUNCTION 1\n");

  fprintf(*output, "toplevel .param\n");
  fprintf(*output, "wm title .param \" \"\n");
  fprintf(*output, "wm maxsize .param 1000 1000\n");
  fprintf(*output, "wm iconname .param \"Grapher-3D function\"\n");

  fprintf(*output, "frame .param.frame1\n");
  fprintf(*output, "frame .param.frame2 -relief sunken -bd 2\n");
  fprintf(*output, "frame .param.frame4\n");


/*Action Bar*/

  fprintf(*output, "button .param.frame2.apply -width 20 -bg grey -text update -command apply\n");
  fprintf(*output, "button .param.frame2.close -width 20 -bg grey -text close -command {set FUNCTION 0;destroy .param}\n");
  fprintf(*output, "pack .param.frame2.apply .param.frame2.close -side left -fill both -expand 1\n");

/*Rotation values*/

  fprintf(*output, "frame .param.frame4.rot\n");
  fprintf(*output, "label .param.frame4.rot.label -text \"Axis Rotation (radians)\"\n");
  fprintf(*output, "frame .param.frame4.rot.val\n");
  fprintf(*output, "label .param.frame4.rot.val.lx -text x\n");
  fprintf(*output, "label .param.frame4.rot.val.ly -text y\n");
  fprintf(*output, "label .param.frame4.rot.val.lz -text z\n");
  fprintf(*output, "entry .param.frame4.rot.val.x -relief sunken -width 8 -bg grey -textvariable xrot\n");
  fprintf(*output, "entry .param.frame4.rot.val.y -relief sunken -width 8 -bg grey -textvariable yrot\n");
  fprintf(*output, "entry .param.frame4.rot.val.z -relief sunken -width 8 -bg grey -textvariable zrot\n");
  fprintf(*output, "pack .param.frame4.rot.val.lx .param.frame4.rot.val.x -side left -padx 1m\n");
  fprintf(*output, "pack .param.frame4.rot.val.ly .param.frame4.rot.val.y -side left -padx 1m\n");
  fprintf(*output, "pack .param.frame4.rot.val.lz .param.frame4.rot.val.z -side left -padx 1m\n");
  fprintf(*output, "pack .param.frame4.rot.label .param.frame4.rot.val\n");
  fprintf(*output, "pack .param.frame4.rot\n");

/*Function Section*/

  fprintf(*output, "frame .param.frame1.function \n");
  fprintf(*output, "label .param.frame1.function.label -text \"Function f(x,y)\"\n");
  fprintf(*output, "entry .param.frame1.function.entry -relief sunken -width 20 -bg grey -textvariable f \n");
  fprintf(*output, "pack .param.frame1.function.label\n");
  fprintf(*output, "pack .param.frame1.function.entry -fill x -expand 1\n");
  fprintf(*output, "pack .param.frame1.function -side left -fill both -expand 1 -padx 3m\n");

/*Domain Entries*/

  fprintf(*output, "frame .param.frame1.domain\n");
  fprintf(*output, "label .param.frame1.domain.label -text Domain\n");
  fprintf(*output, "frame .param.frame1.domain.x\n");
  fprintf(*output, "frame .param.frame1.domain.y\n");
  fprintf(*output, "entry .param.frame1.domain.x.minx -textvariable minx -width 6 -bg grey -relief sunken\n");
  fprintf(*output, "label .param.frame1.domain.x.label -text \"< x <\"\n");
  fprintf(*output, "entry .param.frame1.domain.x.maxx -textvariable maxx -width 6 -bg grey -relief sunken\n");
  fprintf(*output, "entry .param.frame1.domain.y.miny -textvariable miny -width 6 -bg grey -relief sunken\n");
  fprintf(*output, "label .param.frame1.domain.y.label -text \"< y <\"\n");
  fprintf(*output, "entry .param.frame1.domain.y.maxy -textvariable maxy -width 6 -bg grey -relief sunken\n");
  fprintf(*output, "pack .param.frame1.domain.x.minx .param.frame1.domain.x.label .param.frame1.domain.x.maxx -side left\n");
  fprintf(*output, "pack .param.frame1.domain.y.miny .param.frame1.domain.y.label .param.frame1.domain.y.maxy -side left\n");
  fprintf(*output, "pack .param.frame1.domain.label .param.frame1.domain.x .param.frame1.domain.y\n");
  fprintf(*output, "pack .param.frame1.domain -side left -padx 3m\n");

  fprintf(*output, "pack .param.frame2 -padx 1m -pady 1m -side bottom -fill both -expand 1\n");
  fprintf(*output, "pack .param.frame1 -fill both -expand 1 -padx 1m -pady 1m\n");
  fprintf(*output, "pack .param.frame4 -padx 1m -pady 1m\n");

  fprintf(*output, "}\n");

  /*Apply stuff*/

  fprintf(*output, "proc apply {} {\n");
  fprintf(*output, "global f;global COLOR;global BACKGROUND;global RES\n");
  fprintf(*output, "global minx;global maxx;global miny;global maxy\n");
  fprintf(*output, "global ZOOM;global EXAG;\n");
  fprintf(*output, "global xrot;global yrot;global zrot\n");
  fprintf(*output, "set f [string trim $f]\n");
  fprintf(*output, "puts f$f;flush stdout\n"); 
  fprintf(*output, "puts l$minx;flush stdout \n"); 
  fprintf(*output, "puts m$maxx;flush stdout \n"); 
  fprintf(*output, "puts n$miny;flush stdout \n"); 
  fprintf(*output, "puts o$maxy;flush stdout \n"); 
  fprintf(*output, "set COLOR [string trim $COLOR]\n");
  fprintf(*output, "puts c$COLOR;flush stdout\n"); 
  fprintf(*output, "set RES [string trim $RES]\n");
  fprintf(*output, "puts $RES;flush stdout\n"); 
  fprintf(*output, "set EXAG [string trim $EXAG]\n");
  fprintf(*output, "puts $EXAG;flush stdout\n"); 
  fprintf(*output, "set ZOOM [string trim $ZOOM]\n");
  fprintf(*output, "puts $ZOOM;flush stdout\n"); 
  fprintf(*output, "puts $xrot;flush stdout\n"); 
  fprintf(*output, "puts $yrot;flush stdout \n"); 
  fprintf(*output, "puts $zrot;flush stdout \n"); 
  fprintf(*output, "set geom [wm geometry .]\n"); 
  fprintf(*output, "puts $geom;flush stdout\n"); 


  fprintf(*output, "set BACKGROUND [string trim $BACKGROUND]\n"); 
  fprintf(*output, ".canvas configure -bg $BACKGROUND\n"); 
  fprintf(*output, "}\n");

  fprintf(*output, "proc domainshift {} {\n");
  fprintf(*output, "global minx maxx miny maxy\n");
  fprintf(*output, "puts D$minx;flush stdout\n"); 
  fprintf(*output, "puts $maxx;flush stdout\n"); 
  fprintf(*output, "puts $miny;flush stdout\n"); 
  fprintf(*output, "puts $maxy;flush stdout\n"); 
  fprintf(*output, "}\n");


/*******************Surface************************/

  fprintf(*output, "proc surf {} {\n");

  fprintf(*output, "global SURFACE\n");
  fprintf(*output, "set SURFACE 1\n");

  fprintf(*output, "toplevel .surface\n");
  fprintf(*output, "wm title .surface \" \"\n");
  fprintf(*output, "wm iconname .surface \"Grapher-3d surface\"\n");

  fprintf(*output, "label .surface.label1 -text \"Surface Focus\"\n");
  fprintf(*output, "label .surface.label2 -text \"Surface Color\"\n");

/*Action Bar*/

  fprintf(*output, "frame .surface.action -bd 1 -relief sunken\n");
  fprintf(*output, "button .surface.action.apply -width 12 -bg grey -text update -command apply\n"); 
  fprintf(*output, "button .surface.action.close -width 12 -bg grey -text close -command {set SURFACE 0;destroy .surface}\n");
  fprintf(*output, "pack .surface.action.apply .surface.action.close -side left -fill both -expand 1\n");

  fprintf(*output, "frame .surface.color\n");
  fprintf(*output, "frame .surface.color.f\n");
  fprintf(*output, "frame .surface.color.b\n");
  fprintf(*output, "label .surface.color.f.label -width 12 -text Foreground -anchor w\n");
  fprintf(*output, "entry .surface.color.f.entry -relief sunken -width 12 -bg grey -textvariable COLOR\n");
  fprintf(*output, "label .surface.color.b.label -width 12 -text Background -anchor w\n");
  fprintf(*output, "entry .surface.color.b.entry -relief sunken -width 12 -bg grey -textvariable BACKGROUND\n");
  fprintf(*output, "pack .surface.color.f.label .surface.color.f.entry -side left\n");
  fprintf(*output, "pack .surface.color.b.label .surface.color.b.entry -side left\n");
  fprintf(*output, "pack .surface.color.f .surface.color.b\n");

  fprintf(*output, "frame .surface.focus\n");
  fprintf(*output, "frame .surface.focus.z\n");
  fprintf(*output, "frame .surface.focus.r\n");
  fprintf(*output, "frame .surface.focus.e\n");
  fprintf(*output, "label .surface.focus.z.label -width 15 -text zoom -anchor w\n");
  fprintf(*output, "label .surface.focus.r.label -width 15 -text resolution -anchor w\n");
  fprintf(*output, "label .surface.focus.e.label -width 15 -text exaggeration -anchor w\n");
  fprintf(*output, "entry .surface.focus.z.entry -relief sunken -width 8 -bg grey -textvariable ZOOM\n");
  fprintf(*output, "entry .surface.focus.r.entry -relief sunken -width 8 -bg grey -textvariable RES\n");
  fprintf(*output, "entry .surface.focus.e.entry -relief sunken -width 8 -bg grey -textvariable EXAG\n");
  fprintf(*output, "pack .surface.focus.z.label .surface.focus.z.entry -side left\n");
  fprintf(*output, "pack .surface.focus.r.label .surface.focus.r.entry -side left\n");
  fprintf(*output, "pack .surface.focus.e.label .surface.focus.e.entry -side left\n");
  fprintf(*output, "pack .surface.focus.z .surface.focus.r .surface.focus.e\n");

  fprintf(*output, "pack .surface.action -side bottom -fill both -expand 1 -pady 2m -padx 2m\n");
  fprintf(*output, "pack .surface.label1 -pady 1m\n");
  fprintf(*output, "pack .surface.focus  -pady 1m\n");
  fprintf(*output, "pack .surface.label2 -pady 1m\n");
  fprintf(*output, "pack .surface.color  -pady 1m\n");
  fprintf(*output, "}\n");

  fprintf(*output, "about\n");

  fflush(*output);
  return 0;
}



